blob: 9fbcf5ed0ca778e1713fff945c9f211488d47a86 [file] [log] [blame]
Linus Torvalds1da177e2005-04-16 15:20:36 -07001# Makefile for the different targets used to generate full packages of a kernel
2# It uses the generic clean infrastructure of kbuild
3
Linus Torvalds1da177e2005-04-16 15:20:36 -07004# RPM target
5# ---------------------------------------------------------------------------
6# The rpm target generates two rpm files:
7# /usr/src/packages/SRPMS/kernel-2.6.7rc2-1.src.rpm
8# /usr/src/packages/RPMS/i386/kernel-2.6.7rc2-1.<arch>.rpm
9# The src.rpm files includes all source for the kernel being built
10# The <arch>.rpm includes kernel configuration, modules etc.
11#
12# Process to create the rpm files
13# a) clean the kernel
14# b) Generate .spec file
15# c) Build a tar ball, using symlink to make kernel version
16# first entry in the path
17# d) and pack the result to a tar.gz file
18# e) generate the rpm files, based on kernel.spec
19# - Use /. to avoid tar packing just the symlink
20
Frans Popdb9038c2009-08-25 22:15:39 +020021# Note that the rpm-pkg target cannot be used with KBUILD_OUTPUT,
22# but the binrpm-pkg target can; for some reason O= gets ignored.
23
Linus Torvalds1da177e2005-04-16 15:20:36 -070024# Remove hyphens since they have special meaning in RPM filenames
Arun Sharmae1287eb2011-05-04 13:48:11 -070025KERNELPATH := kernel-$(subst -,_,$(KERNELRELEASE))
Riku Voipio37160012015-09-02 12:57:24 +030026KDEB_SOURCENAME ?= linux-$(KERNELRELEASE)
27export KDEB_SOURCENAME
Michal Marek6615d6c2013-04-12 14:12:50 +020028# Include only those top-level files that are needed by make, plus the GPL copy
Riku Voipio26803822015-09-02 12:57:08 +030029TAR_CONTENT := $(KBUILD_ALLDIRS) .config .scmversion Makefile \
Michal Marek6615d6c2013-04-12 14:12:50 +020030 Kbuild Kconfig COPYING $(wildcard localversion*)
Linus Torvalds1da177e2005-04-16 15:20:36 -070031MKSPEC := $(srctree)/scripts/package/mkspec
Linus Torvalds1da177e2005-04-16 15:20:36 -070032
Riku Voipio26803822015-09-02 12:57:08 +030033quiet_cmd_src_tar = TAR $(2).tar.gz
34 cmd_src_tar = \
Masahiro Yamada262dad62017-12-06 19:32:57 +090035set -e; \
Riku Voipio26803822015-09-02 12:57:08 +030036if test "$(objtree)" != "$(srctree)"; then \
Masahiro Yamada262dad62017-12-06 19:32:57 +090037 echo >&2; \
38 echo >&2 " ERROR:"; \
39 echo >&2 " Building source tarball is not possible outside the"; \
40 echo >&2 " kernel source tree. Don't set KBUILD_OUTPUT, or use the"; \
41 echo >&2 " binrpm-pkg or bindeb-pkg target instead."; \
42 echo >&2; \
Riku Voipio26803822015-09-02 12:57:08 +030043 false; \
44fi ; \
45$(srctree)/scripts/setlocalversion --save-scmversion; \
Riku Voipio26803822015-09-02 12:57:08 +030046tar -cz $(RCS_TAR_IGNORE) -f $(2).tar.gz \
Masahiro Yamada2dbc6442017-11-15 18:17:07 +090047 --transform 's:^:$(2)/:S' $(TAR_CONTENT) $(3); \
48rm -f $(objtree)/.scmversion
Riku Voipio26803822015-09-02 12:57:08 +030049
Linus Torvalds1da177e2005-04-16 15:20:36 -070050# rpm-pkg
Sam Ravnborg01317052006-03-08 18:39:05 +010051# ---------------------------------------------------------------------------
Masahiro Yamadaebaad7d2017-11-15 18:19:20 +090052rpm-pkg: FORCE
Linus Torvalds1da177e2005-04-16 15:20:36 -070053 $(MAKE) clean
Michal Marek65013202013-04-13 21:21:15 +020054 $(CONFIG_SHELL) $(MKSPEC) >$(objtree)/kernel.spec
Riku Voipio26803822015-09-02 12:57:08 +030055 $(call cmd,src_tar,$(KERNELPATH),kernel.spec)
Masahiro Yamada8a16a072017-09-30 10:10:11 +090056 +rpmbuild $(RPMOPTS) --target $(UTS_MACHINE) -ta $(KERNELPATH).tar.gz \
57 --define='_smp_mflags %{nil}'
Linus Torvalds1da177e2005-04-16 15:20:36 -070058
59# binrpm-pkg
Sam Ravnborg01317052006-03-08 18:39:05 +010060# ---------------------------------------------------------------------------
Michal Marek65013202013-04-13 21:21:15 +020061binrpm-pkg: FORCE
Sam Ravnborga91f98a2005-07-14 20:26:09 +000062 $(MAKE) KBUILD_SRC=
Michal Marek65013202013-04-13 21:21:15 +020063 $(CONFIG_SHELL) $(MKSPEC) prebuilt > $(objtree)/binkernel.spec
Masahiro Yamada606625b2017-09-30 10:10:09 +090064 +rpmbuild $(RPMOPTS) --define "_builddir $(objtree)" --target \
Luiz Capitulinof66ba562013-05-15 12:06:26 -040065 $(UTS_MACHINE) -bb $(objtree)/binkernel.spec
Masahiro Yamadaaf60e202017-09-30 10:10:10 +090066
67clean-files += $(objtree)/*.spec
Linus Torvalds1da177e2005-04-16 15:20:36 -070068
69# Deb target
70# ---------------------------------------------------------------------------
Jonathan Niederdb1d1862009-11-24 09:21:56 -060071quiet_cmd_builddeb = BUILDDEB
72 cmd_builddeb = set -e; \
73 test `id -u` = 0 || \
74 test -n "$(KBUILD_PKG_ROOTCMD)" || { \
75 which fakeroot >/dev/null 2>&1 && \
76 KBUILD_PKG_ROOTCMD="fakeroot -u"; \
77 } || { \
78 echo; \
79 echo "builddeb must be run as root (or using fakeroot)."; \
80 echo "KBUILD_PKG_ROOTCMD is unset and fakeroot not found."; \
81 echo "Try setting KBUILD_PKG_ROOTCMD to a command to acquire"; \
82 echo "root privileges (e.g., 'fakeroot -u' or 'sudo')."; \
83 false; \
84 } && \
85 \
86 $$KBUILD_PKG_ROOTCMD $(CONFIG_SHELL) \
Riku Voipio37160012015-09-02 12:57:24 +030087 $(srctree)/scripts/package/builddeb $@
Jonathan Niederdb1d1862009-11-24 09:21:56 -060088
Sam Ravnborg01317052006-03-08 18:39:05 +010089deb-pkg: FORCE
Riku Voipio37160012015-09-02 12:57:24 +030090 $(MAKE) clean
91 $(call cmd,src_tar,$(KDEB_SOURCENAME))
Sam Ravnborga91f98a2005-07-14 20:26:09 +000092 $(MAKE) KBUILD_SRC=
Riku Voipio37160012015-09-02 12:57:24 +030093 +$(call cmd,builddeb)
94
95bindeb-pkg: FORCE
96 $(MAKE) KBUILD_SRC=
97 +$(call cmd,builddeb)
Linus Torvalds1da177e2005-04-16 15:20:36 -070098
99clean-dirs += $(objtree)/debian/
100
Paolo Pisati5704d452017-11-27 12:07:34 +0100101# snap-pkg
102# ---------------------------------------------------------------------------
103snap-pkg: FORCE
104 rm -rf $(objtree)/snap
105 mkdir $(objtree)/snap
106 $(MAKE) clean
107 $(call cmd,src_tar,$(KERNELPATH))
108 sed "s@KERNELRELEASE@$(KERNELRELEASE)@; \
109 s@SRCTREE@$(shell realpath $(KERNELPATH).tar.gz)@" \
110 $(srctree)/scripts/package/snapcraft.template > \
111 $(objtree)/snap/snapcraft.yaml
112 cd $(objtree)/snap && \
113 snapcraft --target-arch=$(UTS_MACHINE)
114
115clean-dirs += $(objtree)/snap/
Linus Torvalds1da177e2005-04-16 15:20:36 -0700116
Jan-Benedict Glaw6d983fe2005-05-24 11:27:37 +0200117# tarball targets
118# ---------------------------------------------------------------------------
Sam Ravnborg01317052006-03-08 18:39:05 +0100119tar%pkg: FORCE
Jan-Benedict Glaw6073aa62006-01-01 14:23:47 +0100120 $(MAKE) KBUILD_SRC=
Jan-Benedict Glaw6d983fe2005-05-24 11:27:37 +0200121 $(CONFIG_SHELL) $(srctree)/scripts/package/buildtar $@
122
123clean-dirs += $(objtree)/tar-install/
124
125
Arnaldo Carvalho de Melo8e5564e2010-05-31 11:13:21 -0300126# perf-pkg - generate a source tarball with perf source
127# ---------------------------------------------------------------------------
128
129perf-tar=perf-$(KERNELVERSION)
130
131quiet_cmd_perf_tar = TAR
132 cmd_perf_tar = \
matt mooney3bdccc82011-05-13 16:41:12 -0700133git --git-dir=$(srctree)/.git archive --prefix=$(perf-tar)/ \
134 HEAD^{tree} $$(cd $(srctree); \
Riku Voipio4b63f602015-09-01 17:14:21 +0300135 echo $$(cat tools/perf/MANIFEST)) \
matt mooney3bdccc82011-05-13 16:41:12 -0700136 -o $(perf-tar).tar; \
Arnaldo Carvalho de Melo8e5564e2010-05-31 11:13:21 -0300137mkdir -p $(perf-tar); \
matt mooney3bdccc82011-05-13 16:41:12 -0700138git --git-dir=$(srctree)/.git rev-parse HEAD > $(perf-tar)/HEAD; \
David Aherna614d012013-11-06 08:55:35 -0700139(cd $(srctree)/tools/perf; \
Riku Voipio4b63f602015-09-01 17:14:21 +0300140util/PERF-VERSION-GEN $(CURDIR)/$(perf-tar)/); \
David Aherna614d012013-11-06 08:55:35 -0700141tar rf $(perf-tar).tar $(perf-tar)/HEAD $(perf-tar)/PERF-VERSION-FILE; \
Arnaldo Carvalho de Melo8e5564e2010-05-31 11:13:21 -0300142rm -r $(perf-tar); \
143$(if $(findstring tar-src,$@),, \
144$(if $(findstring bz2,$@),bzip2, \
145$(if $(findstring gz,$@),gzip, \
Zdenek Kaspar9a17f402011-01-30 12:18:51 +0100146$(if $(findstring xz,$@),xz, \
147$(error unknown target $@)))) \
Arnaldo Carvalho de Melo8e5564e2010-05-31 11:13:21 -0300148 -f -9 $(perf-tar).tar)
149
150perf-%pkg: FORCE
151 $(call cmd,perf_tar)
152
Linus Torvalds1da177e2005-04-16 15:20:36 -0700153# Help text displayed when executing 'make help'
154# ---------------------------------------------------------------------------
Sam Ravnborg01317052006-03-08 18:39:05 +0100155help: FORCE
Arnaldo Carvalho de Melo8e5564e2010-05-31 11:13:21 -0300156 @echo ' rpm-pkg - Build both source and binary RPM kernel packages'
Riku Voipio37160012015-09-02 12:57:24 +0300157 @echo ' binrpm-pkg - Build only the binary kernel RPM package'
158 @echo ' deb-pkg - Build both source and binary deb kernel packages'
159 @echo ' bindeb-pkg - Build only the binary kernel deb package'
Paolo Pisati5704d452017-11-27 12:07:34 +0100160 @echo ' snap-pkg - Build only the binary kernel snap package (will connect to external hosts)'
Arnaldo Carvalho de Melo8e5564e2010-05-31 11:13:21 -0300161 @echo ' tar-pkg - Build the kernel as an uncompressed tarball'
162 @echo ' targz-pkg - Build the kernel as a gzip compressed tarball'
163 @echo ' tarbz2-pkg - Build the kernel as a bzip2 compressed tarball'
Zdenek Kaspar9a17f402011-01-30 12:18:51 +0100164 @echo ' tarxz-pkg - Build the kernel as a xz compressed tarball'
Arnaldo Carvalho de Melo8e5564e2010-05-31 11:13:21 -0300165 @echo ' perf-tar-src-pkg - Build $(perf-tar).tar source tarball'
166 @echo ' perf-targz-src-pkg - Build $(perf-tar).tar.gz source tarball'
167 @echo ' perf-tarbz2-src-pkg - Build $(perf-tar).tar.bz2 source tarball'
Zdenek Kaspar9a17f402011-01-30 12:18:51 +0100168 @echo ' perf-tarxz-src-pkg - Build $(perf-tar).tar.xz source tarball'